POJ 3683 Priest John's Busiest Day(2-SAT 并输出解)
Description
John is the only priest in his town. September 1st is the John's busiest day in a year because there is an old legend in the town that the couple who get married on that day will be forever blessed by the God of Love. This year N couples plan to get married on the blessed day. The i-th couple plan to hold their wedding from time Si to time Ti. According to the traditions in the town, there must be a special ceremony on which the couple stand before the priest and accept blessings. The i-th couple need Di minutes to finish this ceremony. Moreover, this ceremony must be either at the beginning or the ending of the wedding (i.e. it must be either from Si to Si + Di, or from Ti - Di to Ti). Could you tell John how to arrange his schedule so that he can present at every special ceremonies of the weddings.
Note that John can not be present at two weddings simultaneously.
Input
The first line contains a integer N ( 1 ≤ N ≤ 1000).
The next N lines contain the Si, Ti and Di. Si and Ti are in the format of hh:mm.
Output
The first line of output contains "YES" or "NO" indicating whether John can be present at every special ceremony. If it is "YES", output another N lines describing the staring time and finishing time of all the ceremonies.
题目大意:给n个婚礼,每个婚礼要举办一次祝福,这个祝福只能在婚礼的开始或结束的时候举办(大大的2SAT标志),问能否举办所有祝福,并输出祝福的时间段(任意解)。
思路:可以参考国家集训队2003年伍昱的论文,判冲连边就成。
PS:这题各种不严谨,没说Ti - Si ≥ Di,没保证不会超过24小时,反正都忽视掉是可以AC的,不忽视能不能AC我就不知道了……
#include <cstdio>
#include <cstring> const int MAXN = *;
const int MAXM = MAXN * MAXN * ; struct Topological{
int St[MAXN], c;
int n, ecnt, cnt;
int head[MAXN], order[MAXN], indeg[MAXN];
int next[MAXM], to[MAXM]; void addEdge(int x, int y){
to[ecnt] = y; next[ecnt] = head[x]; head[x] = ecnt++;
++indeg[y];
//printf("%d->%d\n",x,y);
} void init(int nn){
n = nn; ecnt = ;
memset(head, , sizeof(head));
memset(indeg,,sizeof(indeg));
} void build(){
c = cnt = ;
for(int i = ; i <= n; ++i)
if(indeg[i] == ) St[++c] = i;
while(c > ){
int u = St[c--]; order[cnt++] = u;
for(int p = head[u]; p; p = next[p]){
int &v = to[p];
--indeg[v];
if(indeg[v] == ) St[++c] = v;
}
}
}
} T; struct TwoSAT{
int St[MAXN], c;
int n, ecnt, dfs_clock, scc_cnt;
int head[MAXN], sccno[MAXN], pre[MAXN], lowlink[MAXN];
int next[MAXM], to[MAXM];
int select[MAXN], sccnox[MAXN]; void dfs(int u){
lowlink[u] = pre[u] = ++dfs_clock;
St[++c] = u;
for(int p = head[u]; p; p = next[p]){
int &v = to[p];
if(!pre[v]){
dfs(v);
if(lowlink[u] > lowlink[v]) lowlink[u] = lowlink[v];
}else if(!sccno[v]){
if(lowlink[u] > pre[v]) lowlink[u] = pre[v];
}
}
if(lowlink[u] == pre[u]){
sccnox[++scc_cnt] = u;
while(true){
int x = St[c--];
sccno[x] = scc_cnt;
if(x == u) break;
}
}
} void init(int nn){
n = nn;
ecnt = ; dfs_clock = scc_cnt = ;
memset(head,,sizeof(head));
memset(pre,,sizeof(pre));
memset(sccno,,sizeof(sccno));
} void addEdge(int x, int y){//x, y clash
to[ecnt] = y^; next[ecnt] = head[x]; head[x] = ecnt++;
to[ecnt] = x^; next[ecnt] = head[y]; head[y] = ecnt++;
//printf("%d<>%d\n",x,y);
} bool solve(){
for(int i = ; i < n; ++i)
if(!pre[i]) dfs(i);
for(int i = ; i < n; i += )
if(sccno[i] == sccno[i^]) return false;
return true;
} void bulid_select(){
T.init(scc_cnt);
for(int u = ; u < n; ++u){
for(int p = head[u]; p; p = next[p]){
int &v = to[p];
if(sccno[u] == sccno[v]) continue;
T.addEdge(sccno[u], sccno[v]);
}
}
T.build();
memset(select,,sizeof(select));
for(int i = T.n - ; i > ; --i) {
int &x = T.order[i];
if(select[x] == -){
select[x] = ;
select[sccno[sccnox[x]^]] = ;
}
}
}
} G; const int MAXNN = ; int a1[MAXNN], b1[MAXNN], a2[MAXNN], b2[MAXNN], a3[MAXNN], b3[MAXNN], c[MAXNN]; inline bool clash(int beg1, int end1, int beg2, int end2){
if(end1 <= beg2 || end2 <= beg1) return false;
return true;
} int main(){
int n;
while(scanf("%d", &n)!=EOF){
G.init(n*);
for(int i = ; i < n; ++i) {
scanf("%d:%d %d:%d %d", &a1[i], &a2[i], &b1[i], &b2[i], &c[i]);
a3[i] = a1[i] * + a2[i];
b3[i] = b1[i] * + b2[i];
}
for(int i = ; i < n; ++i) for(int j = i+; j < n; ++j) if(i != j){
if(clash(a3[i], a3[i] + c[i], a3[j], a3[j] + c[j])) G.addEdge(i*, j*);
if(clash(a3[i], a3[i] + c[i], b3[j] - c[j], b3[j])) G.addEdge(i*, j*+);
if(clash(b3[i] - c[i], b3[i], a3[j], a3[j] + c[j])) G.addEdge(i*+, j*);
if(clash(b3[i] - c[i], b3[i], b3[j] - c[j], b3[j])) G.addEdge(i*+, j*+);
}
if(G.solve()) printf("YES\n");
else {printf("NO\n"); continue;}
G.bulid_select();
for(int i = ; i < n; ++i){
//printf("%d %d\n",i*2,G.sccno[i*2]);
if(G.select[G.sccno[i*]]){
b1[i] = a1[i]; b2[i] = a2[i] + c[i];
while(b2[i] >= ) ++b1[i], b2[i] -= ;
} else {
a1[i] = b1[i]; a2[i] = b2[i] - c[i];
while(a2[i] < ) --a1[i], a2[i] += ;
}
printf("%02d:%02d %02d:%02d\n", a1[i], a2[i], b1[i], b2[i]);
}
}
return ;
}
141MS
后记:
上面那个输出解的方法略显麻烦了,看到了一个新的方法,就是若sccno[2i]<sccno[2i+1]就选i,否则选i的对立面,不用求拓扑排序了。省了一大堆代码量。
证明:
对于任意点a、b(设~a、~b分别为他们的对立面),rank为他们的拓扑序号
那么我们选择a当且仅当rank[a]>rank[~a],选择b当且仅当rank[b]>rank[~b]
假设a和b有矛盾,那么有a到~b有路径(由对称性b到~a有路径),则rank[~b]>rank[a](rank[~a]>rank[b])
联合上式,有rank[a]>rank[~a]>rank[b]>rank[~b]>rank[a]矛盾
假设不成立,a和b没有矛盾
所以对于任意点a,选择a当且仅当rank[a]>rank[~a]是合法的
当我们用tarjan求强联通分量的时候,实际上求出来的scnno[]的值便是一个逆序的拓扑排序值。
仔细想想这没什么问题,因为再tarjan求强联通分量的时候,对于任意点x,它的后继顶点一定会比x先编入强联通分量,那么x的后继一定要比x的scnno值要小。
代码(125MS):
#include <cstdio>
#include <cstring> const int MAXN = *;
const int MAXM = MAXN * MAXN * ; struct TwoSAT{
int St[MAXN], c;
int n, ecnt, dfs_clock, scc_cnt;
int head[MAXN], sccno[MAXN], pre[MAXN], lowlink[MAXN];
int next[MAXM], to[MAXM]; void dfs(int u){
lowlink[u] = pre[u] = ++dfs_clock;
St[++c] = u;
for(int p = head[u]; p; p = next[p]){
int &v = to[p];
if(!pre[v]){
dfs(v);
if(lowlink[u] > lowlink[v]) lowlink[u] = lowlink[v];
}else if(!sccno[v]){
if(lowlink[u] > pre[v]) lowlink[u] = pre[v];
}
}
if(lowlink[u] == pre[u]){
++scc_cnt;
while(true){
int x = St[c--];
sccno[x] = scc_cnt;
if(x == u) break;
}
}
} void init(int nn){
n = nn;
ecnt = ; dfs_clock = scc_cnt = ;
memset(head,,sizeof(head));
memset(pre,,sizeof(pre));
memset(sccno,,sizeof(sccno));
} void addEdge(int x, int y){//x, y clash
to[ecnt] = y^; next[ecnt] = head[x]; head[x] = ecnt++;
to[ecnt] = x^; next[ecnt] = head[y]; head[y] = ecnt++;
//printf("%d<>%d\n",x,y);
} bool solve(){
for(int i = ; i < n; ++i)
if(!pre[i]) dfs(i);
for(int i = ; i < n; i += )
if(sccno[i] == sccno[i^]) return false;
return true;
}
} G; const int MAXNN = ; int a1[MAXNN], b1[MAXNN], a2[MAXNN], b2[MAXNN], a3[MAXNN], b3[MAXNN], c[MAXNN]; inline bool clash(int beg1, int end1, int beg2, int end2){
if(end1 <= beg2 || end2 <= beg1) return false;
return true;
} int main(){
int n;
while(scanf("%d", &n)!=EOF){
G.init(n*);
for(int i = ; i < n; ++i) {
scanf("%d:%d %d:%d %d", &a1[i], &a2[i], &b1[i], &b2[i], &c[i]);
a3[i] = a1[i] * + a2[i];
b3[i] = b1[i] * + b2[i];
}
for(int i = ; i < n; ++i) for(int j = i+; j < n; ++j) if(i != j){
if(clash(a3[i], a3[i] + c[i], a3[j], a3[j] + c[j])) G.addEdge(i*, j*);
if(clash(a3[i], a3[i] + c[i], b3[j] - c[j], b3[j])) G.addEdge(i*, j*+);
if(clash(b3[i] - c[i], b3[i], a3[j], a3[j] + c[j])) G.addEdge(i*+, j*);
if(clash(b3[i] - c[i], b3[i], b3[j] - c[j], b3[j])) G.addEdge(i*+, j*+);
}
if(G.solve()) printf("YES\n");
else {printf("NO\n"); continue;}
for(int i = ; i < n; ++i){
if(G.sccno[i * ] < G.sccno[i * + ]) {
b1[i] = a1[i]; b2[i] = a2[i] + c[i];
while(b2[i] >= ) ++b1[i], b2[i] -= ;
} else {
a1[i] = b1[i]; a2[i] = b2[i] - c[i];
while(a2[i] < ) --a1[i], a2[i] += ;
}
printf("%02d:%02d %02d:%02d\n", a1[i], a2[i], b1[i], b2[i]);
}
}
return ;
}
POJ 3683 Priest John's Busiest Day(2-SAT 并输出解)的更多相关文章
- POJ 3683 Priest John's Busiest Day(2-SAT+方案输出)
Priest John's Busiest Day Time Limit: 2000MS Memory Limit: 65536K Total Submissions: 10010 Accep ...
- POJ 3683 Priest John's Busiest Day / OpenJ_Bailian 3788 Priest John's Busiest Day(2-sat问题)
POJ 3683 Priest John's Busiest Day / OpenJ_Bailian 3788 Priest John's Busiest Day(2-sat问题) Descripti ...
- POJ 3683 Priest John's Busiest Day (2-SAT)
Priest John's Busiest Day Time Limit: 2000MS Memory Limit: 65536K Total Submissions: 6900 Accept ...
- poj - 3683 - Priest John's Busiest Day(2-SAT)
题意:有N场婚礼,每场婚礼的开始时间为Si,结束时间为Ti,每场婚礼有个仪式,历时Di,这个仪式要么在Si时刻开始,要么在Ti-Di时刻开始,问能否安排每场婚礼举行仪式的时间,使主持人John能参加所 ...
- POJ 3683 Priest John's Busiest Day (2-SAT)
题意:有n对新人要在同一天结婚.结婚时间为Ti到Di,这里有时长为Si的一个仪式需要神父出席.神父可以在Ti-(Ti+Si)这段时间出席也可以在(Di-Si)-Si这段时间.问神父能否出席所有仪式,如 ...
- POJ 3683 Priest John's Busiest Day (2-SAT,常规)
题意: 一些人要在同一天进行婚礼,但是牧师只有1个,每一对夫妻都有一个时间范围[s , e]可供牧师选择,且起码要m分钟才主持完毕,但是要么就在 s 就开始,要么就主持到刚好 e 结束.因为人数太多了 ...
- POJ 3683 Priest John's Busiest Day
2-SAT简单题,判断一下两个开区间是否相交 #include<cstdio> #include<cstring> #include<cmath> #include ...
- POJ 3683 Priest John's Busiest Day[2-SAT 构造解]
题意: $n$对$couple$举行仪式,有两个时间段可以选择,问是否可以不冲突举行完,并求方案 两个时间段选择对应一真一假,对于有时间段冲突冲突的两人按照$2-SAT$的规则连边(把不冲突的时间段连 ...
- POJ 3683 Priest John's Busiest Day 【2-Sat】
这是一道裸的2-Sat,只要考虑矛盾条件的判断就好了. 矛盾判断: 对于婚礼现场 x 和 y,x 的第一段可以和 y 的第一段或者第二段矛盾,同理,x 的第二段可以和 y 的第一段或者第二段矛盾,条件 ...
随机推荐
- GO语言练习:第一个Go语言工程--排序
1.代码 2.编译 3.运行 1.代码框架 /home/fengbo/sorter $ tree . ├── bin ├── pkg ├── readme.txt └── src ├── algori ...
- Spring中@Async用法总结
引言: 在Java应用中,绝大多数情况下都是通过同步的方式来实现交互处理的:但是在处理与第三方系统交互的时候,容易造成响应迟缓的情况,之前大部分都是使用多线程来完成此类任务,其实,在Spring 3. ...
- About_MySQL Select--来自copy_03
MySQL Select 查询分类 单表查询:简单查询 多表查询:连接查询 联合查询:多个查询结果汇总 查询的组成 投影查询:挑选要显示的字段 select array1,array2,... f ...
- 条件查询,有input和select框,当查询条件获取焦点时支持摁下enter键查询
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding= ...
- 高德地图 室内地图 API 的一些坑
开发指南 http://lbs.amap.com/api/javascript-api/guide/create-map/indoormap/ demo 大全: http://lbs.amap.com ...
- decode 函数将字符串从某种编码转为 unicode 字符
环境:Ubuntu, Python 2.7 基础知识 这个程序涉及到的知识点有几个,在这里列出来,不详细讲,有疑问的直接百度会有一堆的. 1.urllib2 模块的 request 对像来设置 HTT ...
- gcc和g++
一.GCC GNU编译器套件(GNU Compiler Collection)包括C.C++.Objective-C.Fortran.Java.Ada和Go语言的前端,也包括了这些语言的库(如libs ...
- windows内核 内存管理
一.几个基本的概念 1.存储器的金字塔结构 存储器从下之上依次是磁盘/flash.DRAM(内存).L2-cache.L1-cache.寄存器,越在上面的存储器访问速度越快,同时价格也越昂贵,每一级都 ...
- Final-阶段站立会议2
组名:天天向上 组长:王森 组员:张政.张金生.林莉.胡丽娜 代码地址:HTTPS:https://git.coding.net/jx8zjs/llk.git SSH:git@git.coding.n ...
- HDU 1828 Picture(线段树扫描线求周长)
Picture Time Limit: 6000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Su ...